////////////////////////////////////////////////////////////////////////////////
//
// (C) 2010 Sarah Eris Horsley Caffee
//
// mandelbrot - A simple Mandelbrot Set viewer.
//
// Julia.h
// Julia set calculator class definition
//
////////////////////////////////////////////////////////////////////////////////

#ifndef JULIA_H
#define JULIA_H

#include <string>

#include "SDL.h"

#include "Fractal.h"

#define JULIA_TYPE_NAME "Julia"

class Julia : public Fractal
   {
   public:
   Julia();

   bool calc_set();
   bool init(SDL_Surface * surf);

   bool get_option(std::string option, void * value);
   bool set_option(std::string option, void * value);

   const char * get_type_name();

   private:

   void draw_pixel(int x, int y, Uint32 * color);
   void set_display_name();

   double k_re;
   double k_im;
   };

namespace
   {
   class JuliaCreator : public FractalCreator
      {
      public:
      JuliaCreator()
	 {
	 get_Fractal_map()["Julia"]=this;
	 }
      virtual Fractal * create() const
	 {
	 return new Julia;
	 }
      } theCreator;
   }
#endif
