////////////////////////////////////////////////////////////////////////////////
//
// (C) 2010 Sarah Eris Horsley Caffee
//
// mandelbrot - A simple Mandelbrot Set viewer.
//
// Mandelbrot.h
// Mandelbrot set calculator class definition
//
////////////////////////////////////////////////////////////////////////////////

#ifndef MANDELBROT_H
#define MANDELBROT_H

#include <string>

#include "SDL.h"

#include "Fractal.h"

#define MANDELBROT_TYPE_NAME "Mandelbrot"

class Mandelbrot : public Fractal
   {
   public:
   Mandelbrot();

   bool calc_set();
   bool init(SDL_Surface * surf);

   const char * get_type_name();

   private:

   void draw_pixel(int x, int y, Uint32 * color);
   };

namespace
   {
   class MandelbrotCreator : public FractalCreator
      {
      public:
      MandelbrotCreator()
	 {
	 get_Fractal_map()["Mandelbrot"]=this;
	 }

      virtual Fractal * create() const
	 {
	 return new Mandelbrot;
	 }
      } theCreator;
   }

#endif
