////////////////////////////////////////////////////////////////////////////////
//
// (C) 2010 Sarah Eris Horsley Caffee
//
// mandelbrot
//
// A simple Mandelbrot Set viewer.   Written in honor of Benoit Mandelbrot,
// who died two days ago on Oct 14, 2010.
//
// main.cpp
//
////////////////////////////////////////////////////////////////////////////////

#include <exception>
#include <iostream>

#include "App.h"

////////////////////////////////////////////////////////////////////////////////

int main (int argc, char* argv[])
   {
   int retval = 0;

   try
      {
      App the_app;
      retval = the_app.run();
      }
   catch (const std::exception & error)
      {
      std::string e = "An unanticipated error has occurred.  Please contacct the developers and report the following information:\nCaught exception: ";
      e += error.what();
      std::cerr << e << std::endl;
      retval = 1;
      }

   return retval;;
   }
